<?php
class pkg_hikainvoices_tax_europeInstallerScript {
	function preflight($type, $parent){
		$version = explode('.',PHP_VERSION);
		if(!defined('DS'))
			define('DS', DIRECTORY_SEPARATOR);
		$hikashopFile = rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_hikashop'.DS.'helpers'.DS.'helper.php';
		if(!file_exists($hikashopFile)) {
			echo '<html><body><h1>This Tax package can only be installed for HikaShop.</h1>'.
					'<h2>Please install HikaShop (starter, essential or business) before installing this package.</h2>'.
					'installation abort...</body></html>';
			exit;
		}
		include_once($hikashopFile);

		/*
		* Create records for all EU Countries + their local VAT Tax Rates per 1 January 2015
		*/
		$this->_query("
INSERT IGNORE INTO `#__hikashop_tax` (`tax_namekey`, `tax_rate`, `invoice_tax_icc`, `invoice_tax_moss_taxcode`) VALUES
('VAT', '0.21000', '', NULL),
('VAT International', '0.00000', '', NULL),
('VAT EU B2B Intra', '0.00000', '', NULL),
('VAT AT Standard', '0.20000', '', NULL),
('VAT BE Standard', '0.21000', '', NULL),
('VAT BG Standard', '0.20000', '', NULL),
('VAT CY Standard', '0.19000', '', NULL),
('VAT CZ Standard', '0.21000', '', NULL),
('VAT DK Standard', '0.25000', '', NULL),
('VAT DE Standard', '0.19000', '', NULL),
('VAT EE Standard', '0.20000', '', NULL),
('VAT GR Standard', '0.23000', '', NULL),
('VAT ES Standard', '0.21000', '', NULL),
('VAT FI Standard', '0.24000', '', NULL),
('VAT FR Standard', '0.20000', '', NULL),
('VAT FR Reduced_1', '0.05500', '', 'RED'),
('VAT HR Standard', '0.25000', '', NULL),
('VAT HU Standard', '0.27000', '', NULL),
('VAT IE Standard', '0.23000', '', NULL),
('VAT IT Standard', '0.22000', '', NULL),
('VAT LV Standard', '0.21000', '', NULL),
('VAT LT Standard', '0.21000', '', NULL),
('VAT LU Standard', '0.15000', '', NULL),
('VAT LU Lowest', '0.03000', '', 'RED'),
('VAT MC Standard', '0.20000', 'FR', ''),
('VAT MC Reduced_1', '0.05500', 'FR', 'RED'),
('VAT MT Standard', '0.18000', '', NULL),
('VAT NL Standard', '0.21000', '', NULL),
('VAT PL Standard', '0.23000', '', NULL),
('VAT PT Standard', '0.23000', '', NULL),
('VAT RO Standard', '0.24000', '', NULL),
('VAT SE Standard', '0.25000', '', NULL),
('VAT SI Standard', '0.22000', '', NULL),
('VAT SK Standard', '0.20000', '', NULL),
('VAT UK Standard', '0.20000', '', NULL)
;");


		/*
		* Create new Tax Category for electronic goods and services

		*/
		
		
		$this->_query("
INSERT IGNORE INTO `#__hikashop_category` (`category_id`, `category_parent_id`, `category_type`, `category_name`, `category_description`, `category_published`, `category_ordering`, `category_left`, `category_right`, `category_depth`, `category_namekey`, `category_alias`, `invoice_category_moss_service_code`, `invoice_category_eu_cn_code`) VALUES
(0, 3, 'tax', 'Services', '', 1, 2, 7, 18, 2, 'tax_services', 'services', NULL, NULL),
(0, 3, 'tax',     'Consultancy', '', 1, 1, 8, 9, 3, 'tax_consultancy', 'consultancy', NULL, NULL),
(0, 3, 'tax',     'Electronic services', '<p>Until January 1st 2015, within the EU the&nbsp;VAT on e-services (like telecommunications, radio &amp; television broadcasting and electronic services) to consumers (and businesses without VAT number) is charged based on the location (EU country) of the seller. <br /> <br />Starting on January 1st 2015, the VAT on e-services to consumers within the EU must be calculated based on the end customer’s location (address on invoice).<br /><br />See <a href=\"http://ec.europa.eu/taxation_customs/taxation/vat/traders/e-commerce/index_en.htm\">http://ec.europa.eu/taxation_customs/taxation/vat/traders/e-commerce/index_en.htm</a></p>', 1, 2, 10, 17, 3, 'tax_electronic_services', 'electronic-services', '', ''),
(0, 3, 'tax',        'Download software', '<p>When the vendor is located in Europe AND the customer is located in Europe</p>\r\n<p>In 2014</p>\r\n<p>=&gt; If B2C then tax rate = VENDOR</p>\r\n<p>=&gt; If B2B then tax rate = 0 + special mention on the invoice (required)</p>\r\n<p> </p>\r\n<p>In 2015</p>\r\n<p>=&gt; If B2C then tax rate = CUSTOMER + special mention on the invoice (required)</p>\r\n<p>=&gt; If B2B then tax rate = 0 + special mention on the invoice (required)</p>', 1, 1, 11, 12, 4, 'tax_download_software', 'download-software', 'SB', ''),
(0, 3, 'tax',        'eBook', '<p>When the vendor is located in Europe AND the customer is located in Europe</p>\r\n<p>In 2014</p>\r\n<p>=&gt; If B2C then tax rate = VENDOR</p>\r\n<p>=&gt; If B2B then tax rate = 0 + special mention on the invoice required</p>\r\n<p> </p>\r\n<p>In 2015</p>\r\n<p>=&gt; If B2C then tax rate = CUSTOMER + special mention on the invoice required</p>\r\n<p>=&gt; If B2B then tax rate = 0 + special mention on the invoice required</p>', 1, 2, 13, 14, 4, 'tax_ebook', 'ebook', 'SC', ''),
(0, 3, 'tax',        'Distance teaching', '<p>Automatic Distance teaching provided by a server.<br />This does NOT include the human distance support that would be provided by a person</p>', 1, 3, 15, 16, 4, 'tax_distance_training', 'distance-teaching', 'SE', '')
;");

		// Rebuild the hierarchy (category dependencies, parent/child)
		$database = JFactory::getDBO();
		$database->setQuery( 'SELECT category_id FROM #__hikashop_category where category_namekey="tax_services"');
		$parent_id = $database->loadResult();
		$this->_query('UPDATE #__hikashop_category SET category_parent_id='.$parent_id.' WHERE category_namekey="tax_consultancy" OR category_namekey="tax_electronic_services"');

		$database->setQuery( 'SELECT category_id FROM #__hikashop_category where category_namekey="tax_electronic_services"');
		$parent_id = $database->loadResult();
		$this->_query('UPDATE #__hikashop_category SET category_parent_id='.$parent_id.' WHERE category_namekey IN ( "tax_download_software",  "tax_ebook", "tax_distance_training")');

		
		/*
		* Create new Taxation rules for all EU countries for "eservice" products.

		Digital goods and services that are sold to:
		- customers in EU countries are taxed on the rate of the customer's country
		- businesses *without* VAT number in EU countries are taxed on the rate of the business's country
		- businesses *with* VAT number in EU countries will be taxed under "VAT Exempt"

		Note: Selling digital goods or services to customers and businesses in your own country
		should be taxed on your country's VAT tax. Change it after you have imported via
		Joomla back-end: Components > Hikashop > System > Taxes.

		*/
		$config = JFactory::getConfig();
		if(!HIKASHOP_J30){
			$timeoffset = $config->getValue('config.offset');
		} else {
			$timeoffset = $config->get('offset');
		}
		$this->_query(str_replace('1420070400',1420070400-$timeoffset*60*60+date('Z'),"
INSERT IGNORE INTO `#__hikashop_taxation` (`taxation_id`, `zone_namekey`, `category_namekey`, `tax_namekey`, `taxation_published`, `taxation_type`, `taxation_access`, `taxation_cumulative`, `taxation_post_code`, `taxation_date_start`, `taxation_date_end`, `taxation_internal_code`, `taxation_note`) VALUES
# (0, 'country_Belgium_21', 'default_tax', 'VAT', 1, '', 'all', 0, '', 0, 0, '0', ''),

# international
(0, '', 'default_tax', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),
(0, '', 'default_tax', 'VAT International', 1, '', 'all', 0, '', 0, 0, '70101-06', 'TAX_EU_DIR2008_8_ART59'),
(0, '', 'tax_services', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),
(0, '', 'tax_services', 'VAT International', 1, '', 'all', 0, '', 0, 0, '70101-06', 'TAX_EU_DIR2008_8_ART59'),
(0, '', '', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),
(0, '', '', 'VAT International', 1, '', 'all', 0, '', 0, 0, '70101-06', 'TAX_EU_DIR2008_8_ART59'),

# Europe (default)
(0, 'tax_europe_9728', 'default_tax', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),
(0, 'tax_europe_9728', 'tax_services', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),
(0, 'tax_europe_9728', '', 'VAT EU B2B Intra', 1, 'company_with_vat_number', 'all', 0, '', 0, 0, '70103', 'TAX_EU_DIR2008_8_ART44 TAX_EU_DIR2008_8_ART196'),

# Europe (B2C)
(0, 'country_Austria_14', 'tax_electronic_services', 'VAT AT Standard', 1, '', 'all', 0, '', 1420070400, 0, '70425-948', 'TAX_EU_2015_B2C'),
(0, 'country_Belgium_21', 'tax_electronic_services', 'VAT BE Standard', 1, '', 'all', 0, '', 1420070400, 0, '70330-929', 'TAX_EU_2015_B2C'),
(0, 'country_Bulgaria_33', 'tax_electronic_services', 'VAT BG Standard', 1, '', 'all', 0, '', 1420070400, 0, '70335-930', 'TAX_EU_2015_B2C'),
(0, 'country_Czech_Republic_56', 'tax_electronic_services', 'VAT CZ Standard', 1, '', 'all', 0, '', 1420070400, 0, '70340-931 ', 'TAX_EU_2015_B2C'),
(0, 'country_Denmark_57', 'tax_electronic_services', 'VAT DK Standard', 1, '', 'all', 0, '', 1420070400, 0, '70345-932 ', 'TAX_EU_2015_B2C'),
(0, 'country_Germany_81', 'tax_electronic_services', 'VAT DE Standard', 1, '', 'all', 0, '', 1420070400, 0, '70350-933', 'TAX_EU_2015_B2C'),
(0, 'country_Estonia_67', 'tax_electronic_services', 'VAT EE Standard', 1, '', 'all', 0, '', 1420070400, 0, '70355-934', 'TAX_EU_2015_B2C'),
(0, 'country_Greece_84', 'tax_electronic_services', 'VAT GR Standard', 1, '', 'all', 0, '', 1420070400, 0, '70360-935', 'TAX_EU_2015_B2C'),
(0, 'country_Spain_195', 'tax_electronic_services', 'VAT ES Standard', 1, '', 'all', 0, '', 1420070400, 0, '70365-936', 'TAX_EU_2015_B2C'),
(0, 'country_France_73', 'tax_electronic_services', 'VAT FR Standard', 1, '', 'all', 0, '', 1420070400, 0, '70370-937', 'TAX_EU_2015_B2C'),
(0, 'country_France_73', 'tax_ebook', 'VAT FR Reduced_1', 1, '', 'all', 0, '', 1420070400, 0, '70371-937', 'TAX_EU_2015_B2C'),
(0, 'country_Croatia_53', 'tax_electronic_services', 'VAT HR Standard', 1, '', 'all', 0, '', 1420070400, 0, '70375-938', 'TAX_EU_2015_B2C'),
(0, 'country_Ireland_103', 'tax_electronic_services', 'VAT IE Standard', 1, '', 'all', 0, '', 1420070400, 0, '70380-938', 'TAX_EU_2015_B2C'),
(0, 'country_Italy_105', 'tax_electronic_services', 'VAT IT Standard', 1, '', 'all', 0, '', 1420070400, 0, '70385-940', 'TAX_EU_2015_B2C'),
(0, 'country_Cyprus_55', 'tax_electronic_services', 'VAT CY Standard', 1, '', 'all', 0, '', 1420070400, 0, '70390-941', 'TAX_EU_2015_B2C'),
(0, 'country_Latvia_117', 'tax_electronic_services', 'VAT LV Standard', 1, '', 'all', 0, '', 1420070400, 0, '70395-942', 'TAX_EU_2015_B2C'),
(0, 'country_Lithuania_123', 'tax_electronic_services', 'VAT LT Standard', 1, '', 'all', 0, '', 1420070400, 0, '70400-943', 'TAX_EU_2015_B2C'),
(0, 'country_Luxembourg_124', 'tax_electronic_services', 'VAT LU Standard', 1, '', 'all', 0, '', 1420070400, 0, '70405-944', 'TAX_EU_2015_B2C'),
(0, 'country_Luxembourg_124', 'tax_ebook', 'VAT LU Lowest', 1, '', 'all', 0, '', 1420070400, 0, '70409-944', 'TAX_EU_2015_B2C'),
(0, 'country_Hungary_97', 'tax_electronic_services', 'VAT HU Standard', 1, '', 'all', 0, '', 1420070400, 0, '70410-945', 'TAX_EU_2015_B2C'),
(0, 'country_Malta_132', 'tax_electronic_services', 'VAT MT Standard', 1, '', 'all', 0, '', 1420070400, 0, '70415-946', 'TAX_EU_2015_B2C'),
(0, 'country_Netherlands_150', 'tax_electronic_services', 'VAT NL Standard', 1, '', 'all', 0, '', 1420070400, 0, '70420-947', 'TAX_EU_2015_B2C'),
(0, 'country_Poland_170', 'tax_electronic_services', 'VAT PL Standard', 1, '', 'all', 0, '', 1420070400, 0, '70430-949', 'TAX_EU_2015_B2C'),
(0, 'country_Portugal_171', 'tax_electronic_services', 'VAT PT Standard', 1, '', 'all', 0, '', 1420070400, 0, '70435-950', 'TAX_EU_2015_B2C'),
(0, 'country_Romania_175', 'tax_electronic_services', 'VAT RO Standard', 1, '', 'all', 0, '', 1420070400, 0, '70440-951', 'TAX_EU_2015_B2C'),
(0, 'country_Slovenia_190', 'tax_electronic_services', 'VAT SI Standard', 1, '', 'all', 0, '', 1420070400, 0, '70445-952 ', 'TAX_EU_2015_B2C'),
(0, 'country_Slovakia_189', 'tax_electronic_services', 'VAT SK Standard', 1, '', 'all', 0, '', 1420070400, 0, '70450-953', 'TAX_EU_2015_B2C'),
(0, 'country_Finland_72', 'tax_electronic_services', 'VAT FI Standard', 1, '', 'all', 0, '', 1420070400, 0, '70455-954', 'TAX_EU_2015_B2C'),
(0, 'country_Sweden_203', 'tax_electronic_services', 'VAT SE Standard', 1, '', 'all', 0, '', 1420070400, 0, '70460-955', 'TAX_EU_2015_B2C'),
(0, 'country_United_Kingdom_222', 'tax_electronic_services', 'VAT UK Standard', 1, '', 'all', 0, '', 1420070400, 0, '70465-956', 'TAX_EU_2015_B2C'),

# Europe (security/rescue rules)
(0, 'tax_europe_9728', 'default_tax', 'VAT', 1, '', 'all', 0, '', 0, 0, '70102-05 ', ''),
(0, 'tax_europe_9728', 'tax_services', 'VAT', 1, '', 'all', 0, '', 0, 0, '70102-05 ', ''),
(0, 'tax_europe_9728', '', 'VAT', 1, '', 'all', 0, '', 0, 0, '70102-05 ', '')

;"));

		/*
		* rebuild categories tree

		*/
		$class = hikashop_get('class.category');
		$database = JFactory::getDBO();
		$query = 'SELECT category_left,category_right,category_depth,category_id,category_parent_id FROM #__hikashop_category ORDER BY category_left ASC';
		$database->setQuery($query);
		$root = null;
		$categories = $database->loadObjectList();
		$class->categories = array();
		foreach($categories as $cat){
			$class->categories[$cat->category_parent_id][]=$cat;
			if(empty($cat->category_parent_id)){
				$root = $cat;
			}
		}
		$class->rebuildTree($root,0,1);

		$app = JFactory::getApplication();
		$app->redirect(hikashop_completeLink('taxation',false,true),'The tax rules for Electronic goods & services sales in the European Union have been installed and will be active from the 1st of January 2015. Please note that these taxes apply only to that type of sales. For other types of goods, other rates will apply and you can modify the rates via the "manage tax rates" button of this page. You can find a full list of all the VAT rates in the European Union in <a href="http://ec.europa.eu/taxation_customs/resources/documents/taxation/vat/how_vat_works/rates/vat_rates_en.pdf" target="_blank">this PDF</a>. Finally, you probably need to edit the "Company with VAT number" tax rule for your country and change its rate from "Exempt" to the tax rate of your country as in most European Countries, the VAT has to be charged for everyone in the country even companies with a VAT number which are only exempted from VAT outside for purchases outside their own country.','message');

		return true;
	}

	function _query($query){
		$database = JFactory::getDBO();
		$database->setQuery($query);
		$database->query();
	}
}